!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
SUBROUTINE PACK_ISBA_PATCH_n(KMASK,KSIZE,KPATCH)
!##############################################
!
!
!!****  *PACK_ISBA_PATCH_n * - packs ISBA variables
!!
!!    PURPOSE
!!    -------
!
!!**  METHOD
!!    ------
!!
!!    REFERENCE
!!    ---------
!!      
!!
!!    AUTHOR
!!    ------
!!     V. Masson and A. boone
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    01/2004
!!      B. Decharme    2008 floodplains
!!      B. Decharme 01/2009 Good dim for XP_TG
!!      A.L. Gibelin 04/2009 : BIOMASS and RESP_BIOMASS arrays 
!!      A.L. Gibelin 04/2009 : TAU_WOOD for NCB option 
!!      A.L. Gibelin 05/2009 : Add carbon spinup
!!      A.L. Gibelin 06/2009 : Soil carbon variables for CNT option
!!      A.L. Gibelin 07/2009 : Suppress RDK and transform GPP as a diagnostic
!!      A.L. Gibelin 07/2009 : Suppress PPST and PPSTF as outputs
!!
!!------------------------------------------------------------------
!
USE MODD_DATA_COVER_PAR,  ONLY : NVEGTYPE
USE MODD_ISBA_n,      ONLY : NGROUND_LAYER,  NNBIOMASS, NNLITTER, NNSOILCARB,       &
                               NNLITTLEVS, CISBA, CPHOTO, CSCOND, CRESPSL,          &
                               LGLACIER, XZ0_O_Z0H, XEMIS, XZ0, XWRMAX_CF, XGAMMA,  &
                               XCV, XRGL, XVEGTYPE_PATCH, XDG, XRUNOFFD, XRUNOFFB,  &
                               XWDRAIN, XTAUICE, XZ0REL, XGAMMAT, NWG_LAYER,        &
                               XC1SAT, XC2REF, XC3, XC4B, XC4REF, XACOEF, XPCOEF,   &
                               XWFC, XWWILT, XWSAT, XBCOEF, XWR, XTG, XWG,          &
                               XWGI, XLAI, XRESA, XVEG, XTDEEP, TSNOW, XROOTFRAC,   &
                               XCONDSAT, XMPOTSAT, XCGSAT, XHCAPSOIL,               &
                               XCONDDRY, XCONDSLD, XRSMIN, XBSLAI, XLAIMIN,         &
                               XSEFOLD, XH_TREE, XANMAX, XFZERO, XEPSO,             &
                               XGAMM, XQDGAMM, XGMES, XRE25, XQDGMES, XT1GMES,      &
                               XT2GMES, XTAU_WOOD, LTR_ML,                          &
                               XAMAX, XQDAMAX, XT1AMAX, XT2AMAX, XAN, XANFM,        &
                               XLE, LSTRESS, XF2I, XGC, XAH, XBH, XDMAX,            &
                               XANDAY, XZ0EFFIP,XZ0EFFIM,XZ0EFFJP,XZ0EFFJM,         &
                               XAOSIP,XAOSIM,XAOSJP,XAOSJM,                         &
                               XHO2IP,XHO2IM,XHO2JP,XHO2JM, XSSO_SLOPE,             &
                               XALBNIR, XALBVIS, XALBUV, XFAPARC, XFAPIRC,          &
                               XALBNIR_VEG, XALBVIS_VEG, XALBUV_VEG, XLAI_EFFC,     &
                               XALBNIR_DRY, XALBVIS_DRY, XALBUV_DRY, XMUS,          &
                               XALBNIR_WET, XALBVIS_WET, XALBUV_WET,                &
                               XALBNIR_SOIL, XALBVIS_SOIL, XALBUV_SOIL,             &
                               XCLAY, XSAND, NPATCH, XBIOMASS, XRESP_BIOMASS,       &
                               XLITTER, XSOILCARB, XLIGNIN_STRUC,                   &
                               XCE_NITRO,XCF_NITRO,XCNA_NITRO,XBSLAI_NITRO,         &
                               XWATSUP,XIRRIG,TSEED,TREAP,                          &
                               CRAIN, XMUF, XFSAT, XKSAT_ICE,                       &
                               XD_ICE, LFLOOD, XFFLOOD, XPIFLOOD, XZ0_FLOOD,        &
                               XPCPS, XPLVTT, XPLSTT, XINCREASE, XTURNOVER,         &
                               XPSN, XPSNG, XPSNV, XPSNV_A, XFF, XFFG, XFFV, XALBF, &
                               XEMISF, XDIR_ALB_WITH_SNOW, XSCA_ALB_WITH_SNOW,      &
                               XICE_STO, XFFROZEN, XDZG, XDZDIF, XSOILWGHT
                             
USE MODD_AGRI,        ONLY : LAGRIP
USE MODD_AGRI_n,      ONLY : LIRRIDAY, XTHRESHOLDSPT, LIRRIGATE
                             
USE MODD_ISBA_GRID_n, ONLY : XLAT, XLON

USE MODD_PACK_ISBA,  ONLY :    NSIZE_LSIMPLE, NSIZE_L0, NSIZE_TSIMPLE,  NSIZE_T0, NSIZE_SIMPLE,  &
                               NSIZE_GROUND, NSIZE_VEGTYPE, NSIZE_TG, NSIZE_SNOW, NSIZE_ALB,     &
                               NSIZE_2, NSIZE_BIOMASS, NSIZE_SOILCARB, NSIZE_LITTLEVS,           &
                               NSIZE_LITTER, NSIZE_0, NSIZE_00, NSIZE_000, NSIZE_01,             &
                               NSIZE_NSIMPLE, NSIZE_N0,                                          &
                               LBLOCK_SIMPLE, LBLOCK_0, TBLOCK_SIMPLE, TBLOCK_0, XBLOCK_SIMPLE,  &
                               XBLOCK_GROUND, XBLOCK_VEGTYPE, XBLOCK_TG, XBLOCK_SNOW, XBLOCK_ALB,&
                               XBLOCK_2, XBLOCK_BIOMASS, XBLOCK_SOILCARB, XBLOCK_LITTLEVS,       &
                               XBLOCK_LITTER, XBLOCK_0, XBLOCK_00, XBLOCK_000, XBLOCK_01,        &
                               NBLOCK_SIMPLE, NBLOCK_0,                                          &
                               XP_Z0_O_Z0H, XP_EMIS, XP_Z0, XP_WRMAX_CF, XP_GAMMA,               &
                               XP_CV, XP_RGL, XP_VEGTYPE_PATCH, XP_DG, XP_RUNOFFD, XP_RUNOFFB,   &
                               XP_WDRAIN, XP_TAUICE, XP_Z0REL, XP_GAMMAT, NK_WG_LAYER,           &
                               XP_C1SAT, XP_C2REF, XP_C3, XP_C4B, XP_C4REF, XP_ACOEF, XP_PCOEF,  &
                               XP_WFC, XP_WWILT, XP_WSAT, XP_BCOEF, XP_WR, XP_TG, XP_WG,         &
                               XP_WGI, XP_LAI, XP_RESA, XP_VEG, XP_TDEEP, XP_ROOTFRAC, XP_DZG,   &
                               XP_DZDIF, XP_CONDSAT, XP_MPOTSAT, XP_CGSAT, XP_HCAPSOIL,          &
                               XP_CONDDRY, XP_CONDSLD, XP_RSMIN, XP_BSLAI, XP_LAIMIN,            &
                               XP_SEFOLD, XP_H_TREE, XP_ANF, XP_ANMAX, XP_FZERO, XP_EPSO,        &
                               XP_GAMM, XP_QDGAMM, XP_GMES, XP_RE25, XP_QDGMES, XP_T1GMES,       &
                               XP_T2GMES, XP_TAU_WOOD,                                           &
                               XP_AMAX, XP_QDAMAX, XP_T1AMAX, XP_T2AMAX, XP_AN, XP_ANFM,         &
                               LP_STRESS, XP_F2I, XP_GC, XP_AH, XP_BH, XP_DMAX, XP_ANDAY,        &
                               XP_Z0EFFIP,XP_Z0EFFIM,XP_Z0EFFJP,XP_Z0EFFJM,                      &
                               XP_AOSIP,XP_AOSIM,XP_AOSJP,XP_AOSJM,                              &
                               XP_HO2IP,XP_HO2IM,XP_HO2JP,XP_HO2JM, XP_SSO_SLOPE,                &
                               XP_SNOWSWE, XP_SNOWRHO, XP_SNOWALB, XP_SNOWHEAT, XP_SNOWEMIS,     &
                               XP_SNOWGRAN1, XP_SNOWGRAN2, XP_SNOWHIST, XP_SNOWAGE,              &
                               XP_LE, XP_ALBNIR, XP_ALBVIS, XP_ALBUV, XP_LAI_EFFC, XP_MUS,       &
                               XP_ALBNIR_VEG, XP_ALBUV_VEG, XP_ALBVIS_VEG,                       &
                               XP_ALBNIR_DRY, XP_ALBVIS_DRY, XP_ALBUV_DRY,                       &
                               XP_ALBNIR_WET, XP_ALBVIS_WET, XP_ALBUV_WET,                       &
                               XP_ALBNIR_SOIL, XP_ALBVIS_SOIL, XP_ALBUV_SOIL,                    &
                               XP_CLAY, XP_SAND, XP_LAT, XP_LON, XP_BIOMASS, XP_RESP_BIOMASS,    &
                               XP_LITTER, XP_SOILCARB, XP_LIGNIN_STRUC, XP_FAPARC, XP_FAPIRC,    &
                               XP_CE_NITRO, XP_CF_NITRO, XP_CNA_NITRO, XP_BSLAI_NITRO,           &
                               TP_SEED,TP_REAP,XP_IRRIG,XP_WATSUP,XP_LIRRIDAY,XP_THRESHOLD,      &
                               XP_LIRRIGATE, XP_MUF, XP_FSAT, XP_KSAT_ICE, XP_D_ICE,             &
                               XP_FFLOOD, XP_Z0FLOOD, XP_PIFLOOD, XP_INCREASE, XP_TURNOVER,      &
                               XP_PSN, XP_PSNG, XP_PSNV, XP_PSNV_A, XP_FF, XP_FFG, XP_FFV,       &
                               XP_CPS, XP_LVTT, XP_LSTT, XP_ALBF, XP_EMISF, XP_DIR_ALB_WITH_SNOW,&
                               XP_SCA_ALB_WITH_SNOW, XP_ICE_STO, XP_FFROZEN, XP_SOILWGHT  
!
USE MODD_CSTS,       ONLY : XLVTT, XLSTT, XCPD
!
USE MODI_ABOR1_SFX
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
INTEGER, INTENT(IN)               :: KSIZE, KPATCH
INTEGER, DIMENSION(:), INTENT(IN) :: KMASK
!
INTEGER :: ISIZE_LSIMPLE, ISIZE_L0, ISIZE_TSIMPLE, ISIZE_T0, ISIZE_SIMPLE,  &
           ISIZE_GROUND, ISIZE_VEGTYPE, ISIZE_TG, ISIZE_SNOW, ISIZE_ALB,    &
           ISIZE_2, ISIZE_BIOMASS, ISIZE_SOILCARB, ISIZE_LITTLEVS,          &
           ISIZE_LITTER, ISIZE_0, ISIZE_00,ISIZE_000, ISIZE_01,             &
           ISIZE_NSIMPLE, ISIZE_N0
!
INTEGER :: JJ, JI, JK, JL 
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('PACK_ISBA_PATCH_N',0,ZHOOK_HANDLE)
!
ALLOCATE(LBLOCK_SIMPLE(KSIZE,NSIZE_LSIMPLE))
ALLOCATE(LBLOCK_0(0,NSIZE_L0))
ALLOCATE(NBLOCK_SIMPLE(KSIZE,NSIZE_NSIMPLE))
ALLOCATE(NBLOCK_0(0,NSIZE_N0))
ALLOCATE(TBLOCK_SIMPLE(KSIZE,NSIZE_TSIMPLE))
ALLOCATE(TBLOCK_0(0,NSIZE_T0))
ALLOCATE(XBLOCK_SIMPLE(KSIZE,NSIZE_SIMPLE))
ALLOCATE(XBLOCK_GROUND(KSIZE,NGROUND_LAYER,NSIZE_GROUND))
ALLOCATE(XBLOCK_VEGTYPE(KSIZE,NVEGTYPE,NSIZE_VEGTYPE))
ALLOCATE(XBLOCK_TG(KSIZE,SIZE(XTG,2),NSIZE_TG))
ALLOCATE(XBLOCK_SNOW(KSIZE,TSNOW%NLAYER,NSIZE_SNOW))
ALLOCATE(XBLOCK_ALB(KSIZE,SIZE(XDIR_ALB_WITH_SNOW,2),NSIZE_ALB))
ALLOCATE(XBLOCK_2(KSIZE,2,NSIZE_2))
ALLOCATE(XBLOCK_BIOMASS(KSIZE,NNBIOMASS,NSIZE_BIOMASS))
ALLOCATE(XBLOCK_SOILCARB(KSIZE,NNSOILCARB,NSIZE_SOILCARB))
ALLOCATE(XBLOCK_LITTLEVS(KSIZE,NNLITTLEVS,NSIZE_LITTLEVS))
ALLOCATE(XBLOCK_LITTER(KSIZE,NNLITTER,NNLITTLEVS,NSIZE_LITTER))
ALLOCATE(XBLOCK_0(0,NSIZE_0))
ALLOCATE(XBLOCK_00(0,0,NSIZE_00))
ALLOCATE(XBLOCK_000(0,0,0,NSIZE_000))
ALLOCATE(XBLOCK_01(0,1,NSIZE_01))
!
ISIZE_LSIMPLE=0
ISIZE_L0=0
ISIZE_NSIMPLE=0
ISIZE_N0=0
ISIZE_TSIMPLE=0
ISIZE_T0=0
ISIZE_SIMPLE=0
ISIZE_GROUND=0
ISIZE_VEGTYPE=0
ISIZE_TG=0
ISIZE_SNOW=0
ISIZE_ALB=0
ISIZE_2=0
ISIZE_BIOMASS=0
ISIZE_LITTER=0
ISIZE_SOILCARB=0
ISIZE_LITTLEVS=0
ISIZE_0=0
ISIZE_00=0
ISIZE_000=0
ISIZE_01=0
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0_O_Z0H     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_EMIS         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBNIR       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBVIS       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBUV        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBNIR_VEG   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBVIS_VEG   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBUV_VEG    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBNIR_SOIL  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBVIS_SOIL  => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBUV_SOIL   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_WRMAX_CF     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_GAMMA        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CV           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RGL          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RUNOFFD      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0EFFIP      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0EFFIM      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0EFFJP      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0EFFJM      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_WR           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LAI          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RESA         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_CPS          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LVTT         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LSTT         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_VEG          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SNOWALB      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LE           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_PSN          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_PSNG         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_PSNV         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBNIR_DRY   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBVIS_DRY   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBUV_DRY    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBNIR_WET   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBVIS_WET   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBUV_WET    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_RUNOFFB      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_WDRAIN       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_TAUICE       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0REL        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_AOSIP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_AOSIM        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_AOSJP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_AOSJM        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HO2IP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HO2IM        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HO2JP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_HO2JM        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_SSO_SLOPE    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_GAMMAT       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_TDEEP        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LAT        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_LON        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_GROUND = ISIZE_GROUND + 1
XP_CLAY         => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_SAND         => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_WFC          => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_WWILT        => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_WSAT         => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_CONDSAT      => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_DG           => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_WG           => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_WGI          => XBLOCK_GROUND(:,:,ISIZE_GROUND)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_KSAT_ICE     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_D_ICE        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
ISIZE_VEGTYPE = ISIZE_VEGTYPE + 1
XP_VEGTYPE_PATCH => XBLOCK_VEGTYPE(:,:,ISIZE_VEGTYPE)
!
ISIZE_TG = ISIZE_TG + 1
XP_TG           => XBLOCK_TG(:,:,ISIZE_TG)
!
ISIZE_SNOW = ISIZE_SNOW + 1
XP_SNOWSWE      => XBLOCK_SNOW(:,:,ISIZE_SNOW)
ISIZE_SNOW = ISIZE_SNOW + 1
XP_SNOWRHO      => XBLOCK_SNOW(:,:,ISIZE_SNOW)
!
ISIZE_ALB = ISIZE_ALB + 1
XP_DIR_ALB_WITH_SNOW=> XBLOCK_ALB(:,:,ISIZE_ALB)
ISIZE_ALB = ISIZE_ALB + 1
XP_SCA_ALB_WITH_SNOW=> XBLOCK_ALB(:,:,ISIZE_ALB)
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FFLOOD       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_PIFLOOD      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_Z0FLOOD      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FF           => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FFG          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FFV          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FFROZEN      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_ALBF         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_EMISF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
XP_FSAT         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
IF(TSNOW%SCHEME=='EBA') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_PSNV_A      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_PSNV_A       => XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (TSNOW%SCHEME=='3-L' .OR. TSNOW%SCHEME=='CRO') THEN
  ISIZE_SNOW = ISIZE_SNOW + 1
   XP_SNOWHEAT   => XBLOCK_SNOW(:,:,ISIZE_SNOW)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_SNOWEMIS   => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWHEAT   => XBLOCK_00(:,:,ISIZE_00) 
  ISIZE_0 = ISIZE_0 + 1
  XP_SNOWEMIS   => XBLOCK_0(:,ISIZE_0)
END IF
!
IF(TSNOW%SCHEME=='CRO') THEN
  ISIZE_SNOW = ISIZE_SNOW + 1
   XP_SNOWGRAN1  => XBLOCK_SNOW(:,:,ISIZE_SNOW)
  ISIZE_SNOW = ISIZE_SNOW + 1
   XP_SNOWGRAN2  => XBLOCK_SNOW(:,:,ISIZE_SNOW)
ISIZE_SNOW = ISIZE_SNOW + 1
   XP_SNOWHIST   => XBLOCK_SNOW(:,:,ISIZE_SNOW)
  ISIZE_SNOW = ISIZE_SNOW + 1
   XP_SNOWAGE    => XBLOCK_SNOW(:,:,ISIZE_SNOW)
ELSE      
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWGRAN1  => XBLOCK_00(:,:,ISIZE_00)  
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWGRAN2  => XBLOCK_00(:,:,ISIZE_00) 
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWHIST   => XBLOCK_00(:,:,ISIZE_00) 
  ISIZE_00 = ISIZE_00 + 1
  XP_SNOWAGE    => XBLOCK_00(:,:,ISIZE_00) 
END IF
!
IF(LGLACIER)THEN  
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1  
   XP_ICE_STO=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE     
  ISIZE_0 = ISIZE_0 + 1
  XP_ICE_STO=> XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (CSCOND=='PL98'.OR.CISBA=='DIF') THEN
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_HCAPSOIL   => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ELSE
  ISIZE_01 = ISIZE_01 + 1
  XP_HCAPSOIL   => XBLOCK_01(:,:,ISIZE_01)
END IF
!
IF (CSCOND=='PL98') THEN
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_CONDDRY    => XBLOCK_GROUND(:,:,ISIZE_GROUND)
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_CONDSLD    => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ELSE
  ISIZE_01 = ISIZE_01 + 1
  XP_CONDDRY    => XBLOCK_01(:,:,ISIZE_01)
  ISIZE_01 = ISIZE_01 + 1
  XP_CONDSLD    => XBLOCK_01(:,:,ISIZE_01)
END IF
!
IF (CISBA=='2-L' .OR. CISBA=='3-L') THEN   
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_C4B          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_ACOEF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
 ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_PCOEF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_CGSAT        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_C1SAT        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_C2REF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_C4REF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)   
  ISIZE_2 = ISIZE_2 + 1
  XP_C3           => XBLOCK_2(:,:,ISIZE_2)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_C4B          => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ACOEF        => XBLOCK_0(:,ISIZE_0) 
 ISIZE_0 = ISIZE_0 + 1
  XP_PCOEF        => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_CGSAT        => XBLOCK_0(:,ISIZE_0) 
  ISIZE_0 = ISIZE_0 + 1
  XP_C1SAT        => XBLOCK_0(:,ISIZE_0) 
  ISIZE_0 = ISIZE_0 + 1
  XP_C2REF        => XBLOCK_0(:,ISIZE_0)   
  ISIZE_0 = ISIZE_0 + 1
  XP_C4REF        => XBLOCK_0(:,ISIZE_0)  
  ISIZE_00 = ISIZE_00 + 1
  XP_C3           => XBLOCK_00(:,:,ISIZE_00)   
END IF
!
ISIZE_GROUND = ISIZE_GROUND + 1
XP_MPOTSAT    => XBLOCK_GROUND(:,:,ISIZE_GROUND)
ISIZE_GROUND = ISIZE_GROUND + 1
XP_BCOEF      => XBLOCK_GROUND(:,:,ISIZE_GROUND)
!
IF (CISBA=='DIF') THEN
!
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_ROOTFRAC   => XBLOCK_GROUND(:,:,ISIZE_GROUND) 
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_DZG        => XBLOCK_GROUND(:,:,ISIZE_GROUND)
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_DZDIF      => XBLOCK_GROUND(:,:,ISIZE_GROUND) 
  ISIZE_GROUND = ISIZE_GROUND + 1
   XP_SOILWGHT   => XBLOCK_GROUND(:,:,ISIZE_GROUND)
!
  ISIZE_NSIMPLE = ISIZE_NSIMPLE + 1
   NK_WG_LAYER   => NBLOCK_SIMPLE(:,ISIZE_NSIMPLE)
!  
ELSE
!
  ISIZE_01 = ISIZE_01 + 1
  XP_ROOTFRAC   => XBLOCK_01(:,:,ISIZE_01)
  ISIZE_01 = ISIZE_01 + 1
  XP_DZG        => XBLOCK_01(:,:,ISIZE_01)
  ISIZE_01 = ISIZE_01 + 1
  XP_DZDIF      => XBLOCK_01(:,:,ISIZE_01)
  ISIZE_01 = ISIZE_01 + 1
  XP_SOILWGHT   => XBLOCK_01(:,:,ISIZE_01)  
!  
  ISIZE_N0 = ISIZE_N0 + 1
   NK_WG_LAYER   => NBLOCK_0(:,ISIZE_N0)
!   
END IF
!
IF (LTR_ML) THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPARC => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_FAPIRC => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_LAI_EFFC => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
  XP_MUS => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)  
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPARC => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_FAPIRC => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LAI_EFFC => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_MUS => XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (CPHOTO=='NON') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_RSMIN      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_RSMIN      => XBLOCK_0(:,ISIZE_0)
END IF
!
ISIZE_SIMPLE = ISIZE_SIMPLE + 1
 XP_H_TREE     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
!
IF (CPHOTO/='NON') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_BSLAI      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_LAIMIN     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_SEFOLD     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_ANF        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_ANMAX      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_FZERO      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_EPSO       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_GAMM       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_QDGAMM     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_GMES       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_RE25       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_QDGMES     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_T1GMES     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_T2GMES     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_AMAX       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_QDAMAX     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_T1AMAX     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_T2AMAX     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_AN         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_ANDAY      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_ANFM       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE) 
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_GC         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_BIOMASS = ISIZE_BIOMASS + 1
  XP_BIOMASS        => XBLOCK_BIOMASS(:,:,ISIZE_BIOMASS)
  ISIZE_BIOMASS = ISIZE_BIOMASS + 1 
  XP_RESP_BIOMASS   => XBLOCK_BIOMASS(:,:,ISIZE_BIOMASS)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_BSLAI      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_LAIMIN     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_SEFOLD     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ANF        => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ANMAX      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_FZERO      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_EPSO       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GAMM       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_QDGAMM     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GMES       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_RE25       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_QDGMES     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_T1GMES     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_T2GMES     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_AMAX       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_QDAMAX     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_T1AMAX     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_T2AMAX     => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_AN         => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ANDAY      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_ANFM       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_GC         => XBLOCK_0(:,ISIZE_0)
  ISIZE_00 = ISIZE_00 + 1
  XP_BIOMASS        => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_00 = ISIZE_00 + 1
  XP_RESP_BIOMASS   => XBLOCK_00(:,:,ISIZE_00)
END IF
!
IF (CPHOTO=='AST' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  ISIZE_LSIMPLE = ISIZE_LSIMPLE + 1
  LP_STRESS     => LBLOCK_SIMPLE(:,ISIZE_LSIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_F2I        => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_AH         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_BH         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_DMAX       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_L0 = ISIZE_L0 + 1
  LP_STRESS     => LBLOCK_0(:,ISIZE_L0)
  ISIZE_0 = ISIZE_0 + 1
  XP_F2I        => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_AH         => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_BH         => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_DMAX       => XBLOCK_0(:,ISIZE_0)
END IF
!
IF (CPHOTO=='LAI' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  ISIZE_TSIMPLE = ISIZE_TSIMPLE + 1
  TP_SEED           => TBLOCK_SIMPLE(:,ISIZE_TSIMPLE)
  ISIZE_TSIMPLE = ISIZE_TSIMPLE + 1
  TP_REAP           => TBLOCK_SIMPLE(:,ISIZE_TSIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_IRRIG          => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_WATSUP         => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  IF (LAGRIP) THEN
     ISIZE_LSIMPLE = ISIZE_LSIMPLE + 1
     XP_LIRRIDAY       => LBLOCK_SIMPLE(:,ISIZE_LSIMPLE)
     ISIZE_SIMPLE = ISIZE_SIMPLE + 1
     XP_THRESHOLD      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
     ISIZE_LSIMPLE = ISIZE_LSIMPLE + 1
     XP_LIRRIGATE      => LBLOCK_SIMPLE(:,ISIZE_LSIMPLE)
  ELSE
     ISIZE_L0 = ISIZE_L0 + 1
     XP_LIRRIDAY       => LBLOCK_0(:,ISIZE_L0)
     ISIZE_0 = ISIZE_0 + 1
     XP_THRESHOLD      => XBLOCK_0(:,ISIZE_0)
     ISIZE_L0 = ISIZE_L0 + 1
     XP_LIRRIGATE      => LBLOCK_0(:,ISIZE_L0)
  ENDIF
ELSE
  ISIZE_T0 = ISIZE_T0 + 1
  TP_SEED           => TBLOCK_0(:,ISIZE_T0)
  ISIZE_T0 = ISIZE_T0 + 1
  TP_REAP           => TBLOCK_0(:,ISIZE_T0)
  ISIZE_0 = ISIZE_0 + 1
  XP_IRRIG          => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_WATSUP         => XBLOCK_0(:,ISIZE_0)
  ISIZE_L0 = ISIZE_L0 + 1
  XP_LIRRIDAY       => LBLOCK_0(:,ISIZE_L0)
  ISIZE_0 = ISIZE_0 + 1
  XP_THRESHOLD      => XBLOCK_0(:,ISIZE_0)
  ISIZE_L0 = ISIZE_L0 + 1
  XP_LIRRIGATE      => LBLOCK_0(:,ISIZE_L0)
ENDIF
!
IF(CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_CE_NITRO       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_CF_NITRO       => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_CNA_NITRO      => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_BSLAI_NITRO    => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_CE_NITRO       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_CF_NITRO       => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_CNA_NITRO      => XBLOCK_0(:,ISIZE_0)
  ISIZE_0 = ISIZE_0 + 1
  XP_BSLAI_NITRO    => XBLOCK_0(:,ISIZE_0)
END IF
!
IF (CPHOTO=='NCB') THEN
  ISIZE_BIOMASS = ISIZE_BIOMASS + 1
  XP_INCREASE     => XBLOCK_BIOMASS(:,:,ISIZE_BIOMASS)
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_TAU_WOOD     => XBLOCK_SIMPLE(:,ISIZE_SIMPLE)  
ELSE
  ISIZE_00 = ISIZE_00 + 1
  XP_INCREASE     => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_0 = ISIZE_0 + 1
  XP_TAU_WOOD     => XBLOCK_0(:,ISIZE_0)
ENDIF
!
IF (CRESPSL=='CNT') THEN
  ISIZE_LITTER = ISIZE_LITTER + 1
  XP_LITTER         => XBLOCK_LITTER(:,:,:,ISIZE_LITTER)
  ISIZE_SOILCARB = ISIZE_SOILCARB + 1
  XP_SOILCARB       => XBLOCK_SOILCARB(:,:,ISIZE_SOILCARB)
  ISIZE_LITTLEVS = ISIZE_LITTLEVS + 1
  XP_LIGNIN_STRUC   => XBLOCK_LITTLEVS(:,:,ISIZE_LITTLEVS)
  ISIZE_BIOMASS = ISIZE_BIOMASS + 1
  XP_TURNOVER       => XBLOCK_BIOMASS(:,:,ISIZE_BIOMASS)
ELSE
  ISIZE_000 = ISIZE_000 + 1
  XP_LITTER         => XBLOCK_000(:,:,:,ISIZE_000)
  ISIZE_00 = ISIZE_00 + 1
  XP_SOILCARB       => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_00 = ISIZE_00 + 1
  XP_LIGNIN_STRUC   => XBLOCK_00(:,:,ISIZE_00)
  ISIZE_00 = ISIZE_00 + 1
  XP_TURNOVER       => XBLOCK_00(:,:,ISIZE_00)
END IF
!
IF (CRAIN=='SGH')THEN
  ISIZE_SIMPLE = ISIZE_SIMPLE + 1
   XP_MUF=> XBLOCK_SIMPLE(:,ISIZE_SIMPLE)
ELSE
  ISIZE_0 = ISIZE_0 + 1
  XP_MUF=> XBLOCK_0(:,ISIZE_0)
ENDIF
!
!
IF (ISIZE_SIMPLE.GT.NSIZE_SIMPLE) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_SIMPLE / NUMBER OF FIELDS")
IF (ISIZE_GROUND.GT.NSIZE_GROUND) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_GROUND / NUMBER OF FIELDS")
IF (ISIZE_VEGTYPE.GT.NSIZE_VEGTYPE) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_VEGTYPE / NUMBER OF FIELDS")
IF (ISIZE_TG.GT.NSIZE_TG) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_TG / NUMBER OF FIELDS")
IF (ISIZE_SNOW.GT.NSIZE_SNOW) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_SNOW / NUMBER OF FIELDS")
IF (ISIZE_ALB.GT.NSIZE_ALB) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_ALB / NUMBER OF FIELDS")
IF (ISIZE_0.GT.NSIZE_0) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_0 / NUMBER OF FIELDS")
IF (ISIZE_00.GT.NSIZE_00) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_00 / NUMBER OF FIELDS")
IF (ISIZE_01.GT.NSIZE_01) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_01 / NUMBER OF FIELDS")
IF (ISIZE_2.GT.NSIZE_2) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_2 / NUMBER OF FIELDS")
IF (ISIZE_BIOMASS.GT.NSIZE_BIOMASS) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_BIOMASS / NUMBER OF FIELDS")
IF (ISIZE_LITTER.GT.NSIZE_LITTER) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_LITTER / NUMBER OF FIELDS")
IF (ISIZE_SOILCARB.GT.NSIZE_SOILCARB) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_SOILCARB / NUMBER OF FIELDS")
IF (ISIZE_LITTLEVS.GT.NSIZE_LITTLEVS) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_LITTLEVS / NUMBER OF FIELDS")
IF (ISIZE_000.GT.NSIZE_000) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_000 / NUMBER OF FIELDS")
IF (ISIZE_TSIMPLE.GT.NSIZE_TSIMPLE) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_TSIMPLE / NUMBER OF FIELDS")
IF (ISIZE_T0.GT.NSIZE_T0) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_T0 / NUMBER OF FIELDS")
IF (ISIZE_LSIMPLE.GT.NSIZE_LSIMPLE) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_LSIMPLE / NUMBER OF FIELDS")
IF (ISIZE_L0.GT.NSIZE_L0) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_L0 / NUMBER OF FIELDS")
IF (ISIZE_N0.GT.NSIZE_N0) &
  CALL ABOR1_SFX("PACK_ISBA_PATCH_n: PROBLEM DEFINING SIZE_N0 / NUMBER OF FIELDS")  
!
!------------------------------------------------------------------------
!
IF (NPATCH==1) THEN
  !
  XP_Z0_O_Z0H     (:)    =    XZ0_O_Z0H     (:, 1)
  XP_EMIS         (:)    =    XEMIS         (:, 1)
  XP_ALBNIR       (:)    =    XALBNIR       (:, 1)
  XP_ALBVIS       (:)    =    XALBVIS       (:, 1)
  XP_ALBUV        (:)    =    XALBUV        (:, 1)
  XP_ALBNIR_VEG   (:)    =    XALBNIR_VEG   (:, 1)
  XP_ALBVIS_VEG   (:)    =    XALBVIS_VEG   (:, 1)
  XP_ALBUV_VEG    (:)    =    XALBUV_VEG    (:, 1)
  XP_ALBNIR_SOIL  (:)    =    XALBNIR_SOIL  (:, 1)
  XP_ALBVIS_SOIL  (:)    =    XALBVIS_SOIL  (:, 1)
  XP_ALBUV_SOIL   (:)    =    XALBUV_SOIL   (:, 1)
  XP_Z0           (:)    =    XZ0           (:, 1)
  XP_WRMAX_CF     (:)    =    XWRMAX_CF     (:, 1)
  XP_GAMMA        (:)    =    XGAMMA        (:, 1)
  XP_CV           (:)    =    XCV           (:, 1)
  XP_RGL          (:)    =    XRGL          (:, 1)
  XP_RUNOFFD      (:)    =    XRUNOFFD      (:, 1) 
  XP_Z0EFFIP      (:)    =    XZ0EFFIP      (:, 1)
  XP_Z0EFFIM      (:)    =    XZ0EFFIM      (:, 1)
  XP_Z0EFFJP      (:)    =    XZ0EFFJP      (:, 1)
  XP_Z0EFFJM      (:)    =    XZ0EFFJM      (:, 1)  
  XP_WR           (:)    =    XWR           (:, 1)   
  XP_LAI          (:)    =    XLAI          (:, 1) 
  XP_RESA         (:)    =    XRESA         (:, 1)
  XP_CPS          (:)    =    XPCPS         (:, 1)
  XP_LVTT         (:)    =    XPLVTT        (:, 1)
  XP_LSTT         (:)    =    XPLSTT        (:, 1) 
  XP_VEG          (:)    =    XVEG          (:, 1)  
  XP_SNOWALB      (:)    =    TSNOW%ALB     (:, 1) 
  XP_LE           (:)    =    XLE           (:, 1)  
  XP_PSN          (:)    =    XPSN          (:, 1)
  XP_PSNG         (:)    =    XPSNG         (:, 1)
  XP_PSNV         (:)    =    XPSNV         (:, 1)  
  XP_ALBNIR_DRY   (:)    =    XALBNIR_DRY   (:)
  XP_ALBVIS_DRY   (:)    =    XALBVIS_DRY   (:)
  XP_ALBUV_DRY    (:)    =    XALBUV_DRY    (:)
  XP_ALBNIR_WET   (:)    =    XALBNIR_WET   (:)
  XP_ALBVIS_WET   (:)    =    XALBVIS_WET   (:)
  XP_ALBUV_WET    (:)    =    XALBUV_WET    (:)  
  XP_RUNOFFB      (:)    =    XRUNOFFB      (:)
  XP_WDRAIN       (:)    =    XWDRAIN       (:)
  XP_TAUICE       (:)    =    XTAUICE       (:)
  XP_Z0REL        (:)    =    XZ0REL        (:)
  XP_AOSIP        (:)    =    XAOSIP        (:)
  XP_AOSIM        (:)    =    XAOSIM        (:)
  XP_AOSJP        (:)    =    XAOSJP        (:)
  XP_AOSJM        (:)    =    XAOSJM        (:)
  XP_HO2IP        (:)    =    XHO2IP        (:)
  XP_HO2IM        (:)    =    XHO2IM        (:)
  XP_HO2JP        (:)    =    XHO2JP        (:)
  XP_HO2JM        (:)    =    XHO2JM        (:)
  XP_SSO_SLOPE    (:)    =    XSSO_SLOPE    (:)
  XP_GAMMAT       (:)    =    XGAMMAT       (:)
  XP_TDEEP        (:)    =    XTDEEP        (:)  
  XP_LAT          (:)    =    XLAT          (:)
  XP_LON          (:)    =    XLON          (:)
  !
  XP_CLAY         (:,:)  =    XCLAY         (:, :)
  XP_SAND         (:,:)  =    XSAND         (:, :) 
  XP_WFC          (:, :) =    XWFC          (:, :)
  XP_WWILT        (:, :) =    XWWILT        (:, :)
  XP_WSAT         (:, :) =    XWSAT         (:, :)
  XP_CONDSAT      (:, :) =    XCONDSAT      (:, :, 1)  
  XP_DG           (:, :) =    XDG           (:, :, 1)  
  XP_WG           (:, :) =    XWG           (:, :, 1)
  XP_WGI          (:, :) =    XWGI          (:, :, 1)
  XP_MPOTSAT      (:, :) =    XMPOTSAT      (:, :) 
  XP_BCOEF        (:, :) =    XBCOEF        (:, :)  
  !
  XP_KSAT_ICE     (:)    =    XKSAT_ICE     (:, 1)
  XP_D_ICE        (:)    =    XD_ICE        (:, 1)
  !
  XP_VEGTYPE_PATCH(:, :) =    XVEGTYPE_PATCH(:, :, 1)  
  !
  XP_TG           (:, :) =    XTG           (:, :, 1)  
  !  
  XP_SNOWSWE      (:, :) =    TSNOW%WSNOW   (:, :, 1)
  XP_SNOWRHO      (:, :) =    TSNOW%RHO     (:, :, 1)  
  !  
  XP_DIR_ALB_WITH_SNOW (:,:)= XDIR_ALB_WITH_SNOW(:, :, 1)
  XP_SCA_ALB_WITH_SNOW (:,:)= XSCA_ALB_WITH_SNOW(:, :, 1)
  !  
  XP_FSAT(:)=XFSAT(:)
  !
  IF(LFLOOD)THEN
    XP_FFLOOD  (:)=XFFLOOD  (:)
    XP_PIFLOOD (:)=XPIFLOOD (:)
    XP_Z0FLOOD (:)=XZ0_FLOOD(:, 1)
    XP_FF      (:)=XFF      (:, 1)
    XP_FFG     (:)=XFFG     (:, 1)
    XP_FFV     (:)=XFFV     (:, 1)    
    XP_FFROZEN (:)=XFFROZEN (:, 1)    
    XP_ALBF    (:)=XALBF    (:, 1)
    XP_EMISF   (:)=XEMISF   (:, 1)
  ELSE
    XP_FFLOOD  (:)= 0.0
    XP_PIFLOOD (:)= 0.0
    XP_FF      (:)= 0.0
    XP_FFG     (:)= 0.0
    XP_FFV     (:)= 0.0
    XP_FFROZEN (:)= 0.0   
    XP_ALBF    (:)= 0.0
    XP_EMISF   (:)= 0.0    
  ENDIF
  !
  IF(TSNOW%SCHEME=='EBA') THEN
    XP_PSNV_A (:)    = XPSNV_A(:, 1)
  ENDIF
  !
  IF (TSNOW%SCHEME=='3-L' .OR. TSNOW%SCHEME=='CRO') THEN
    XP_SNOWHEAT   (:, :) =    TSNOW%HEAT   (:, :, 1)
  END IF
  !
  IF(TSNOW%SCHEME=='CRO') THEN
    XP_SNOWGRAN1  (:,:) =     TSNOW%GRAN1  (:,:,1)
    XP_SNOWGRAN2  (:,:) =     TSNOW%GRAN2  (:,:,1)
    XP_SNOWHIST   (:,:) =     TSNOW%HIST   (:,:,1)  
    XP_SNOWAGE    (:,:) =     TSNOW%AGE    (:,:,1)  
  END IF
  !
  IF(LGLACIER)THEN
    XP_ICE_STO (:)= XICE_STO  (:,1)
  ENDIF
  !  
  IF (CSCOND=='PL98'.OR.CISBA=='DIF') THEN
    XP_HCAPSOIL(:, :) = XHCAPSOIL    (:, :)
  END IF
  !  
  IF (CSCOND=='PL98') THEN
    XP_CONDDRY    (:, :) =    XCONDDRY     (:, :)
    XP_CONDSLD    (:, :) =    XCONDSLD     (:, :)
  END IF
  !
  IF (CISBA=='2-L' .OR. CISBA=='3-L') THEN
    XP_C4B        (:)    =    XC4B          (:)
    XP_ACOEF      (:)    =    XACOEF        (:)
    XP_PCOEF      (:)    =    XPCOEF        (:)
    XP_CGSAT      (:)    =    XCGSAT        (:) 
    XP_C1SAT      (:)    =    XC1SAT        (:, 1)
    XP_C2REF      (:)    =    XC2REF        (:, 1)    
    XP_C4REF      (:)    =    XC4REF        (:, 1)    
    XP_C3         (:,:)  =    XC3           (:,:,1)    
  END IF
  !
  IF (CISBA=='DIF') THEN
    XP_ROOTFRAC   (:, :) =    XROOTFRAC   (:, :, 1)
    XP_DZG        (:, :) =    XDZG        (:, :, 1)
    XP_DZDIF      (:, :) =    XDZDIF      (:, :, 1)
    XP_SOILWGHT   (:, :) =    XSOILWGHT   (:, :, 1)
    NK_WG_LAYER   (:   ) =    NWG_LAYER   (:,    1)
  END IF
  !
  IF (LTR_ML) THEN
    XP_FAPARC     (:)   =     XFAPARC     (:, 1)
    XP_FAPIRC     (:)   =     XFAPIRC     (:, 1)
    XP_LAI_EFFC   (:)   =     XLAI_EFFC   (:, 1)
    XP_MUS        (:)   =     XMUS        (:, 1)
  ENDIF
  !  
  IF (CPHOTO=='NON') THEN
    XP_RSMIN      (:)    =    XRSMIN      (:, 1) 
  END IF
  !
  XP_H_TREE     (:)    =    XH_TREE     (:, 1)
  !
  IF (CPHOTO/='NON') THEN
    XP_BSLAI      (:)    =    XBSLAI      (:, 1)
    XP_LAIMIN     (:)    =    XLAIMIN     (:, 1)
    XP_SEFOLD     (:)    =    XSEFOLD     (:, 1)
    XP_ANMAX      (:)    =    XANMAX      (:, 1)
    XP_FZERO      (:)    =    XFZERO      (:, 1)
    XP_EPSO       (:)    =    XEPSO       (:, 1)
    XP_GAMM       (:)    =    XGAMM       (:, 1)
    XP_QDGAMM     (:)    =    XQDGAMM     (:, 1)
    XP_GMES       (:)    =    XGMES       (:, 1)
    XP_RE25       (:)    =    XRE25       (:, 1)
    XP_QDGMES     (:)    =    XQDGMES     (:, 1)
    XP_T1GMES     (:)    =    XT1GMES     (:, 1)
    XP_T2GMES     (:)    =    XT2GMES     (:, 1)
    XP_AMAX       (:)    =    XAMAX       (:, 1)
    XP_QDAMAX     (:)    =    XQDAMAX     (:, 1)
    XP_T1AMAX     (:)    =    XT1AMAX     (:, 1)
    XP_T2AMAX     (:)    =    XT2AMAX     (:, 1)
    XP_AN         (:)    =    XAN         (:, 1) 
    XP_ANDAY      (:)    =    XANDAY      (:, 1) 
    XP_ANFM       (:)    =    XANFM       (:, 1) 
    XP_GC         (:)    =    XGC         (:, 1)
    XP_BIOMASS        (:,:)  =    XBIOMASS        (:,:,1)
    XP_RESP_BIOMASS   (:,:)  =    XRESP_BIOMASS   (:,:,1)
  END IF
  !
  IF (CPHOTO=='AST' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN  
    LP_STRESS     (:)    =    LSTRESS     (:, 1)
    XP_F2I        (:)    =    XF2I        (:, 1)
    XP_AH         (:)    =    XAH         (:, 1)
    XP_BH         (:)    =    XBH         (:, 1)
    XP_DMAX       (:)    =    XDMAX       (:, 1)
  END IF
  !
  IF(CPHOTO=='LAI' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
    TP_SEED     (:) = TSEED     (:,1)
    TP_REAP     (:) = TREAP     (:,1)
    XP_IRRIG    (:) = XIRRIG    (:,1)
    XP_WATSUP   (:) = XWATSUP   (:,1)
    IF (LAGRIP) THEN
       XP_LIRRIDAY (:) = LIRRIDAY  (:,1)
       XP_THRESHOLD(:) = XTHRESHOLDSPT(:,1)
       XP_LIRRIGATE(:) = LIRRIGATE (:,1)
    END IF
  ENDIF
  !  
  IF(CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN 
     XP_CE_NITRO       (:)  =    XCE_NITRO       (:,1)
     XP_CF_NITRO       (:)  =    XCF_NITRO       (:,1)
     XP_CNA_NITRO      (:)  =    XCNA_NITRO      (:,1)
     XP_BSLAI_NITRO    (:)    =    XBSLAI_NITRO  (:,1)
  END IF
  !
  IF (CPHOTO=='NCB') THEN
     XP_INCREASE       (:,:)  =    XINCREASE       (:,:,1)          
     XP_TAU_WOOD       (:)    =    XTAU_WOOD       (:,1)
  END IF
  !
  IF (CRESPSL=='CNT') THEN
    XP_LITTER         (:,:,:) =    XLITTER         (:,:,:,1)
    XP_SOILCARB       (:,:)   =    XSOILCARB       (:,:,1)
    XP_LIGNIN_STRUC   (:,:)   =    XLIGNIN_STRUC   (:,:,1)
    XP_TURNOVER       (:,:)   =    XTURNOVER       (:,:,1)
  END IF
  !
  IF (CRAIN=='SGH') THEN
    XP_MUF(:)=XMUF(:)
  ENDIF
!
!------------------------------------------------------------------------
ELSE
!------------------------------------------------------------------------
!
  DO JJ=1,KSIZE
    JI                      =    KMASK(JJ)
    XP_Z0_O_Z0H     (JJ)    =    XZ0_O_Z0H     (JI, KPATCH)
    XP_EMIS         (JJ)    =    XEMIS         (JI, KPATCH)
    XP_ALBNIR       (JJ)    =    XALBNIR       (JI, KPATCH)
    XP_ALBVIS       (JJ)    =    XALBVIS       (JI, KPATCH)
    XP_ALBUV        (JJ)    =    XALBUV        (JI, KPATCH)
    XP_ALBNIR_VEG   (JJ)    =    XALBNIR_VEG   (JI, KPATCH)
    XP_ALBVIS_VEG   (JJ)    =    XALBVIS_VEG   (JI, KPATCH)
    XP_ALBUV_VEG    (JJ)    =    XALBUV_VEG    (JI, KPATCH)
    XP_ALBNIR_SOIL  (JJ)    =    XALBNIR_SOIL  (JI, KPATCH)
    XP_ALBVIS_SOIL  (JJ)    =    XALBVIS_SOIL  (JI, KPATCH)
    XP_ALBUV_SOIL   (JJ)    =    XALBUV_SOIL   (JI, KPATCH)
    XP_Z0           (JJ)    =    XZ0           (JI, KPATCH)
    XP_WRMAX_CF     (JJ)    =    XWRMAX_CF     (JI, KPATCH)
    XP_GAMMA        (JJ)    =    XGAMMA        (JI, KPATCH)
    XP_CV           (JJ)    =    XCV           (JI, KPATCH)
    XP_RGL          (JJ)    =    XRGL          (JI, KPATCH)
    XP_RUNOFFD      (JJ)    =    XRUNOFFD      (JI, KPATCH)
    XP_Z0EFFIP      (JJ)    =    XZ0EFFIP      (JI, KPATCH)
    XP_Z0EFFIM      (JJ)    =    XZ0EFFIM      (JI, KPATCH)
    XP_Z0EFFJP      (JJ)    =    XZ0EFFJP      (JI, KPATCH)
    XP_Z0EFFJM      (JJ)    =    XZ0EFFJM      (JI, KPATCH)  
    XP_WR           (JJ)    =    XWR           (JI, KPATCH) 
    XP_LAI          (JJ)    =    XLAI          (JI, KPATCH) 
    XP_RESA         (JJ)    =    XRESA         (JI, KPATCH) 
    XP_CPS          (JJ)    =    XPCPS         (JI, KPATCH)
    XP_LVTT         (JJ)    =    XPLVTT        (JI, KPATCH)
    XP_LSTT         (JJ)    =    XPLSTT        (JI, KPATCH)
    XP_VEG          (JJ)    =    XVEG          (JI, KPATCH) 
    XP_SNOWALB      (JJ)    =    TSNOW%ALB     (JI, KPATCH) 
    XP_LE           (JJ)    =    XLE           (JI, KPATCH) 
    XP_PSN          (JJ)    =    XPSN          (JI, KPATCH)
    XP_PSNG         (JJ)    =    XPSNG         (JI, KPATCH)
    XP_PSNV         (JJ)    =    XPSNV         (JI, KPATCH)    
    XP_ALBNIR_DRY   (JJ)    =    XALBNIR_DRY   (JI)
    XP_ALBVIS_DRY   (JJ)    =    XALBVIS_DRY   (JI)
    XP_ALBUV_DRY    (JJ)    =    XALBUV_DRY    (JI)
    XP_ALBNIR_WET   (JJ)    =    XALBNIR_WET   (JI)
    XP_ALBVIS_WET   (JJ)    =    XALBVIS_WET   (JI)
    XP_ALBUV_WET    (JJ)    =    XALBUV_WET    (JI)    
    XP_RUNOFFB      (JJ)    =    XRUNOFFB      (JI)
    XP_WDRAIN       (JJ)    =    XWDRAIN       (JI)
    XP_TAUICE       (JJ)    =    XTAUICE       (JI)
    XP_Z0REL        (JJ)    =    XZ0REL        (JI)
    XP_AOSIP        (JJ)    =    XAOSIP        (JI)
    XP_AOSIM        (JJ)    =    XAOSIM        (JI)
    XP_AOSJP        (JJ)    =    XAOSJP        (JI)
    XP_AOSJM        (JJ)    =    XAOSJM        (JI)
    XP_HO2IP        (JJ)    =    XHO2IP        (JI)
    XP_HO2IM        (JJ)    =    XHO2IM        (JI)
    XP_HO2JP        (JJ)    =    XHO2JP        (JI)
    XP_HO2JM        (JJ)    =    XHO2JM        (JI)
    XP_SSO_SLOPE    (JJ)    =    XSSO_SLOPE    (JI)
    XP_GAMMAT       (JJ)    =    XGAMMAT       (JI)
    XP_TDEEP        (JJ)    =    XTDEEP        (JI) 
    XP_LAT          (JJ)    =    XLAT          (JI)
    XP_LON          (JJ)    =    XLON          (JI)    
    XP_FSAT         (JJ)    =    XFSAT         (JI)
    XP_H_TREE       (JJ)    =    XH_TREE       (JI, KPATCH)
  ENDDO
  !  
  DO JK=1,NGROUND_LAYER
    DO JJ=1,KSIZE
      JI                       =    KMASK(JJ)
      XP_CLAY         (JJ,JK)  =    XCLAY         (JI, JK)
      XP_SAND         (JJ,JK)  =    XSAND         (JI, JK)
      XP_WFC          (JJ,JK)  =    XWFC          (JI, JK)
      XP_WWILT        (JJ,JK)  =    XWWILT        (JI, JK)
      XP_WSAT         (JJ,JK)  =    XWSAT         (JI, JK)    
      XP_CONDSAT      (JJ,JK)  =    XCONDSAT      (JI, JK, KPATCH)      
      XP_DG           (JJ,JK)  =    XDG           (JI, JK, KPATCH)  
      XP_WG           (JJ,JK)  =    XWG           (JI, JK, KPATCH)
      XP_WGI          (JJ,JK)  =    XWGI          (JI, JK, KPATCH)
      XP_MPOTSAT      (JJ, JK) =    XMPOTSAT      (JI, JK)
      XP_BCOEF        (JJ, JK) =    XBCOEF        (JI, JK)      
    ENDDO    
  ENDDO  
  !  
  DO JJ=1,KSIZE
     JI              = KMASK(JJ)
     XP_KSAT_ICE(JJ) = XKSAT_ICE(JI,KPATCH)
     XP_D_ICE   (JJ) = XD_ICE   (JI,KPATCH)
  END DO
  !
  DO JK=1,NVEGTYPE
    DO JJ=1,KSIZE
      JI                      =    KMASK(JJ)
      XP_VEGTYPE_PATCH(JJ,JK) =    XVEGTYPE_PATCH(JI, JK, KPATCH)
    ENDDO
  ENDDO  
  !
  DO JK=1,SIZE(XTG,2)
    DO JJ=1,KSIZE
      JI                       =    KMASK(JJ)
      XP_TG           (JJ,JK)  =    XTG           (JI, JK, KPATCH)  
    ENDDO
  ENDDO
  !  
  DO JK=1,TSNOW%NLAYER
    DO JJ=1,KSIZE
      JI                       =    KMASK(JJ)
      XP_SNOWSWE      (JJ,JK)  =    TSNOW%WSNOW   (JI, JK, KPATCH)
      XP_SNOWRHO      (JJ,JK)  =    TSNOW%RHO     (JI, JK, KPATCH)
    ENDDO
  ENDDO  
  !  
  DO JK=1,SIZE(XP_DIR_ALB_WITH_SNOW,2)
    DO JJ=1,KSIZE
      JI                          = KMASK(JJ)
      XP_DIR_ALB_WITH_SNOW (JJ,JK)= XDIR_ALB_WITH_SNOW(JI,JK,KPATCH)
      XP_SCA_ALB_WITH_SNOW (JJ,JK)= XSCA_ALB_WITH_SNOW(JI,JK,KPATCH)
    ENDDO
  ENDDO
  !
  IF (LFLOOD)THEN
    DO JJ=1,KSIZE
       JI             = KMASK(JJ)
       XP_FFLOOD  (JJ)=XFFLOOD  (JI)
       XP_PIFLOOD (JJ)=XPIFLOOD (JI)
       XP_Z0FLOOD (JJ)=XZ0_FLOOD(JI,KPATCH)
       XP_FF      (JJ)=XFF      (JI,KPATCH)
       XP_FFG     (JJ)=XFFG     (JI,KPATCH)
       XP_FFV     (JJ)=XFFV     (JI,KPATCH)
       XP_FFROZEN (JJ)=XFFROZEN (JI,KPATCH)    
       XP_ALBF    (JJ)=XALBF    (JI,KPATCH)
       XP_EMISF   (JJ)=XEMISF   (JI,KPATCH)       
    END DO
  ELSE
    XP_FFLOOD  (:) = 0.0
    XP_PIFLOOD (:) = 0.0
    XP_FF      (:) = 0.0
    XP_FFG     (:) = 0.0
    XP_FFROZEN (:) = 0.0
    XP_FFV     (:) = 0.0
    XP_ALBF    (:) = 0.0
    XP_EMISF   (:) = 0.0
  ENDIF
!
  IF(TSNOW%SCHEME=='EBA') THEN
    DO JJ=1,KSIZE
       JI                = KMASK(JJ)
       XP_PSNV_A (JJ)    = XPSNV_A(JI, KPATCH)
    END DO
  END IF
  !
  IF (TSNOW%SCHEME=='3-L' .OR. TSNOW%SCHEME=='CRO') THEN
    DO JK=1,SIZE(XP_SNOWHEAT,2)
      DO JJ=1,KSIZE
        JI                     =    KMASK(JJ)
        XP_SNOWHEAT   (JJ, JK) =    TSNOW%HEAT   (JI, JK, KPATCH)
      ENDDO
    END DO
  END IF
  !
  IF (TSNOW%SCHEME=='CRO') THEN
    DO JK=1,SIZE(XP_SNOWGRAN1,2)
      DO JJ=1,KSIZE
        JI                     =    KMASK(JJ)  
        XP_SNOWGRAN1  (JJ, JK) =    TSNOW%GRAN1  (JI, JK, KPATCH)
        XP_SNOWGRAN2  (JJ, JK) =    TSNOW%GRAN2  (JI, JK, KPATCH)
        XP_SNOWHIST   (JJ, JK) =    TSNOW%HIST   (JI, JK, KPATCH)
        XP_SNOWAGE    (JJ, JK) =    TSNOW%AGE    (JI, JK, KPATCH)
      ENDDO
    END DO
  END IF
  !
  IF(LGLACIER)THEN
    DO JJ=1,KSIZE
       JI             = KMASK(JJ)
       XP_ICE_STO(JJ) = XICE_STO  (JI,KPATCH)
    ENDDO
  ENDIF
  !  
  IF (CSCOND=='PL98'.OR.CISBA=='DIF') THEN
    DO JK=1,SIZE(XHCAPSOIL,2)
      DO JJ=1,KSIZE
        JI                    =    KMASK(JJ)
        XP_HCAPSOIL   (JJ, JK) =    XHCAPSOIL    (JI, JK)
      ENDDO
    ENDDO
  END IF
  !
  IF (CSCOND=='PL98') THEN
    DO JK=1,SIZE(XCONDDRY,2)
      DO JJ=1,KSIZE
        JI                    =    KMASK(JJ)
        XP_CONDDRY    (JJ, JK) =    XCONDDRY     (JI, JK)
        XP_CONDSLD    (JJ, JK) =    XCONDSLD     (JI, JK)
      ENDDO
    ENDDO
  END IF
  !
  IF (CISBA=='2-L' .OR. CISBA=='3-L') THEN
    DO JJ=1,KSIZE
      JI                    =    KMASK(JJ)
      XP_C4B        (JJ)    =    XC4B          (JI)
      XP_ACOEF      (JJ)    =    XACOEF        (JI)
      XP_PCOEF      (JJ)    =    XPCOEF        (JI)
      XP_CGSAT      (JJ)    =    XCGSAT        (JI) 
      XP_C1SAT      (JJ)    =    XC1SAT        (JI, KPATCH)
      XP_C2REF      (JJ)    =    XC2REF        (JI, KPATCH)     
      XP_C4REF      (JJ)    =    XC4REF        (JI, KPATCH)      
    ENDDO
    !
    DO JK=1,SIZE(XC3,2)
      DO JJ=1,KSIZE
        JI                    =    KMASK(JJ)
        XP_C3         (JJ,JK)  =    XC3           (JI, JK, KPATCH)
      ENDDO
    ENDDO
  END IF
  !
    DO JK=1,SIZE(XBCOEF,2)
      DO JJ=1,KSIZE    
         JI                  =    KMASK(JJ)
         XP_MPOTSAT (JJ, JK) =    XMPOTSAT (JI, JK)
         XP_BCOEF   (JJ, JK) =    XBCOEF   (JI, JK)
      ENDDO
    ENDDO
  !
  IF (CISBA=='DIF') THEN
    DO JK=1,SIZE(XROOTFRAC,2)
      DO JJ=1,KSIZE
        JI                     =    KMASK(JJ)
        XP_ROOTFRAC   (JJ, JK) =    XROOTFRAC   (JI, JK, KPATCH)
        XP_DZG        (JJ, JK) =    XDZG        (JI, JK, KPATCH)
        XP_DZDIF      (JJ, JK) =    XDZDIF      (JI, JK, KPATCH)
        XP_SOILWGHT   (JJ, JK) =    XSOILWGHT   (JI, JK, KPATCH)
      ENDDO
    ENDDO
    DO JJ=1,KSIZE
      JI                =  KMASK(JJ)
      NK_WG_LAYER (JJ)  =  NWG_LAYER (JI,KPATCH)
    ENDDO
  ENDIF
  !
  IF (LTR_ML) THEN
    DO JJ=1,KSIZE
      JI                    =    KMASK(JJ)
      XP_FAPARC      (JJ)    =    XFAPARC      (JI, KPATCH)
      XP_FAPIRC      (JJ)    =    XFAPIRC      (JI, KPATCH)
      XP_LAI_EFFC    (JJ)    =    XLAI_EFFC    (JI, KPATCH)
      XP_MUS         (JJ)    =    XMUS         (JI, KPATCH)
    ENDDO
  ENDIF  
  !
  IF (CPHOTO=='NON') THEN
    DO JJ=1,KSIZE
      JI                    =    KMASK(JJ)
      XP_RSMIN      (JJ)    =    XRSMIN      (JI, KPATCH)
    END DO
  END IF
  !
  IF (CPHOTO/='NON') THEN
    DO JJ=1,KSIZE
      JI                    =    KMASK(JJ)
      XP_BSLAI      (JJ)    =    XBSLAI      (JI, KPATCH)
      XP_LAIMIN     (JJ)    =    XLAIMIN     (JI, KPATCH)
      XP_SEFOLD     (JJ)    =    XSEFOLD     (JI, KPATCH)
      XP_ANMAX      (JJ)    =    XANMAX      (JI, KPATCH)
      XP_FZERO      (JJ)    =    XFZERO      (JI, KPATCH)
      XP_EPSO       (JJ)    =    XEPSO       (JI, KPATCH)
      XP_GAMM       (JJ)    =    XGAMM       (JI, KPATCH)
      XP_QDGAMM     (JJ)    =    XQDGAMM     (JI, KPATCH)
      XP_GMES       (JJ)    =    XGMES       (JI, KPATCH)
      XP_RE25       (JJ)    =    XRE25       (JI, KPATCH)
      XP_QDGMES     (JJ)    =    XQDGMES     (JI, KPATCH)
      XP_T1GMES     (JJ)    =    XT1GMES     (JI, KPATCH)
      XP_T2GMES     (JJ)    =    XT2GMES     (JI, KPATCH)
      XP_AMAX       (JJ)    =    XAMAX       (JI, KPATCH)
      XP_QDAMAX     (JJ)    =    XQDAMAX     (JI, KPATCH)
      XP_T1AMAX     (JJ)    =    XT1AMAX     (JI, KPATCH)
      XP_T2AMAX     (JJ)    =    XT2AMAX     (JI, KPATCH)
      XP_AN         (JJ)    =    XAN         (JI, KPATCH) 
      XP_ANDAY      (JJ)    =    XANDAY      (JI, KPATCH) 
      XP_ANFM       (JJ)    =    XANFM       (JI, KPATCH) 
      XP_GC         (JJ)    =    XGC         (JI, KPATCH)
    ENDDO
    DO JK=1,SIZE(XBIOMASS,2)
      DO JJ=1,KSIZE
        JI                    =    KMASK(JJ)
        XP_BIOMASS        (JJ,JK)  =    XBIOMASS        (JI,JK,KPATCH)
        XP_RESP_BIOMASS   (JJ,JK)  =    XRESP_BIOMASS   (JI,JK,KPATCH)
      ENDDO
    END DO
  END IF
  !
  IF (CPHOTO=='AST' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
    DO JJ=1,KSIZE
      JI                    =    KMASK(JJ)
      LP_STRESS     (JJ)    =    LSTRESS     (JI, KPATCH)
      XP_F2I        (JJ)    =    XF2I        (JI, KPATCH)
      XP_AH         (JJ)    =    XAH         (JI, KPATCH)
      XP_BH         (JJ)    =    XBH         (JI, KPATCH)
      XP_DMAX       (JJ)    =    XDMAX       (JI, KPATCH)
    END DO
  END IF
  !
  IF(CPHOTO=='LAI' .OR. CPHOTO=='LST' .OR. CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
    DO JJ=1,KSIZE
      JI               = KMASK(JJ)
      TP_SEED     (JJ) = TSEED     (JI,KPATCH)
      TP_REAP     (JJ) = TREAP     (JI,KPATCH)
      XP_IRRIG    (JJ) = XIRRIG    (JI,KPATCH)
      XP_WATSUP   (JJ) = XWATSUP   (JI,KPATCH)
    ENDDO
    IF (LAGRIP) THEN
      DO JJ=1,KSIZE
        JI               = KMASK(JJ)      
        XP_LIRRIDAY (JJ) = LIRRIDAY  (JI,KPATCH)
        XP_THRESHOLD(JJ) = XTHRESHOLDSPT(JI,KPATCH)
        XP_LIRRIGATE(JJ) = LIRRIGATE (JI,KPATCH)
      ENDDO
    ENDIF
  ENDIF
  !
  IF(CPHOTO=='NIT' .OR. CPHOTO=='NCB') THEN
    DO JJ=1,KSIZE
      JI                      =    KMASK(JJ)
      XP_CE_NITRO       (JJ)  =    XCE_NITRO       (JI,KPATCH)
      XP_CF_NITRO       (JJ)  =    XCF_NITRO       (JI,KPATCH)
      XP_CNA_NITRO      (JJ)  =    XCNA_NITRO      (JI,KPATCH)
      XP_BSLAI_NITRO    (JJ)  =    XBSLAI_NITRO    (JI,KPATCH)      
    END DO
  END IF
  !
  IF (CPHOTO=='NCB') THEN
    DO JK=1,SIZE(XINCREASE,2)
      DO JJ=1,KSIZE
        JI                      =    KMASK(JJ)
        XP_INCREASE   (JJ,JK)   =    XINCREASE       (JI,JK,KPATCH)
      ENDDO
    END DO
    DO JJ=1,KSIZE
      JI                      =    KMASK(JJ)
      XP_TAU_WOOD       (JJ)  =    XTAU_WOOD       (JI,KPATCH)
    END DO  
  END IF
  !
  IF (CRESPSL=='CNT') THEN
    DO JL=1,SIZE(XP_LITTER,3)
      DO JK=1,SIZE(XP_LITTER,2)
        DO JJ=1,KSIZE
          JI                      =    KMASK(JJ)
          XP_LITTER         (JJ,JK,JL) =    XLITTER         (JI,JK,JL,KPATCH)
        ENDDO
      ENDDO
    ENDDO
    DO JK=1,SIZE(XP_SOILCARB,2)
      DO JJ=1,KSIZE
        JI                      =    KMASK(JJ)
        XP_SOILCARB       (JJ,JK)   =    XSOILCARB       (JI,JK,KPATCH)
      ENDDO
    ENDDO
     DO JK=1,SIZE(XP_LIGNIN_STRUC,2)
      DO JJ=1,KSIZE
        JI                      =    KMASK(JJ)
        XP_LIGNIN_STRUC  (JJ,JK)   =    XLIGNIN_STRUC  (JI,JK,KPATCH)
      ENDDO
    ENDDO
    DO JK=1,SIZE(XP_TURNOVER,2)
      DO JJ=1,KSIZE
        JI                      =    KMASK(JJ)
        XP_TURNOVER      (JJ,JK)   =    XTURNOVER       (JI,JK,KPATCH)
      ENDDO
    ENDDO
  END IF
!
  IF (CRAIN=='SGH')THEN
    DO JJ=1,KSIZE
       JI         = KMASK(JJ)
       XP_MUF(JJ) = XMUF(JI)
    END DO
  ENDIF
!
!------------------------------------------------------------------------
END IF
IF (LHOOK) CALL DR_HOOK('PACK_ISBA_PATCH_N',1,ZHOOK_HANDLE)
!------------------------------------------------------------------------
END SUBROUTINE PACK_ISBA_PATCH_n
